<?php

// Function to get category tree for a particular category
function getCategoryTree($parentCat = 0) {
  global $catArr, $CONFIG;

  $parentCat = (int)$parentCat;

  // Query to fetch child categories for $catId
  $query = "SELECT * FROM ".$CONFIG['TABLE_PREFIX']."faqCatgeories WHERE parentCategory = '$parentCat' ORDER BY categoryTitle ASC";
  $result = cpg_db_query($query);

  // If children exist
  if (mysql_num_rows($result) > 0) {
    while ($row = cpg_db_fetch_row($result)) {
      $catId = (int)$row['categoryId'];
      $catTitle = stripslashes($row['categoryTitle']);

      if ($parentCat > 0) {
        $catLevel = (int)($catArr[$parentCat]['level'] + 1);
      } else {
        $catLevel = 0;
      }

      // array[$categoryId] = array('level' => $categoryLevel, 'parent' => $parentCategory, 'title' => $categoryTitle)
      $catArr[$catId] = array('level' => $catLevel, 'parent' => $parentCat, 'title' => $catTitle);

      // Build category tree
      getCategoryTree($catId);
    }
  }
} // End of function 'getCategoryTree'

// Function to check $parentCategory is any child of $categoryId or not
function isChild($parentCategory, $categoryId) {
  global $CONFIG;

  if ($parentCategory == $categoryId) {
    return true;
  }

  $childCats = array();

  // Query to fetch children of $categoryId
  $query = "SELECT categoryId FROM ".$CONFIG['TABLE_PREFIX']."faqCatgeories WHERE parentCategory = '$categoryId' ORDER BY categoryId ASC";
  $result = cpg_db_query($query);

  // If children exist
  if (mysql_num_rows($result) > 0) {
    while ($row = cpg_db_fetch_row($result)) {
      $childCats[] = (int)$row['categoryId'];
    }

    reset($childCats);

    foreach ($childCats as $childCat) {
      if (isChild($parentCategory, $childCat)) {
        return true;
      }
    }
  } else {
    return false;
  }
} // End of function 'isChild'

// Function to get multi-level category dropdown
function getMultilevelCategoriesDropdown() {
  global $catArr, $default_parentCategory;

  $catArr = array();
  getCategoryTree();

  $cdd = '
      <select name="parentCategory">
        <option value="0">No parent category</option>';

  if (count($catArr) > 0) {
    foreach ($catArr as $catId => $catDetails) {
      if ($catId == $default_parentCategory) {
        $selected = ' SELECTED';
      } else {
        $selected = '';
      }

      $spaces = '';

      if ($catDetails['level'] > 0) {
        $spaces .= '|';
      }

      for ($i = 0; $i < $catDetails['level']; $i++) {
        $spaces .= '--';
      }

      if (!empty($spaces)) {
        $spaces .= '&nbsp;';
      }

      if ($catDetails['level'] > 0) {
        $cdd .= '
        <option value="'.$catId.'"'.$selected.'>'.$spaces.$catDetails['title'].'</option>';
      } else {
        $cdd .= '
        <option style="font-weight: bold;" value="'.$catId.'"'.$selected.'>'.$catDetails['title'].'</option>';
      }
    }
  }

  $cdd .= '
      </select>';

  return $cdd;
} // End of function 'getMultilevelCategoriesDropdown'

?>
