<?php

define('IN_COPPERMINE', true);

require('include/init.inc.php');
require('faqFunctions.inc.php');

if (!GALLERY_ADMIN_MODE) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);

if (eregi('sanisoft', $_SERVER['HTTP_HOST'])) {
  $thisDomain = 'http://'.$_SERVER['HTTP_HOST'].'/NagpurBirds/';
} else {
  $thisDomain = $CONFIG['ecards_more_pic_target'];
}

// Build HTML header
$html_header = <<<EOT
<html dir="ltr">
<head>
<title>{$CONFIG['gallery_name']} - Manage FAQ</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<meta http-equiv="Pragma" content="no-cache" />

<link rel="stylesheet" href="themes/{$CONFIG['theme']}/style.css" />
</head>
<body>
<p align="center">[ <a href="#" onClick="window.close();">Close Window</a> ]</p>
EOT;

// Output HTML header
echo $html_header;

// Build array for 'act'
$acts = array('addCategory', 'addFAQ', 'edit');

// If 'act' is valid
if (in_array($_REQUEST['act'], $acts)) {
  switch ($_REQUEST['act']) {
    // For adding category
    case 'addCategory' :
      // Initialize some variables
      $categoryAdded = false;
      $categoryExists = false;
      $default_categoryTitle = '';
      $default_parentCategory = 0;

      // If add category form is posted
      if (!empty($_POST['categoryTitle'])) {
        $_POST['parentCategory'] = (int)$_POST['parentCategory'];
        $_POST['categoryTitle'] = addslashes($_POST['categoryTitle']);

        // Query to check whether category title already exists or not
        $query = "SELECT * FROM ".$CONFIG['TABLE_PREFIX']."faqCatgeories WHERE categoryTitle = '".$_POST['categoryTitle']."'";
        $result = cpg_db_query($query);

        if (mysql_num_rows($result) > 0) {
          $categoryExists = true;
          $default_parentCategory = $_POST['parentCategory'];
          $default_categoryTitle = stripslashes($_POST['categoryTitle']);
        } else {
          // Query to insert category into database table
          $query = "INSERT INTO ".$CONFIG['TABLE_PREFIX']."faqCatgeories SET parentCategory = '".$_POST['parentCategory']."', categoryTitle = '".$_POST['categoryTitle']."'";
          cpg_db_query($query);

          $categoryAdded = true;
        }
      }

      // Calling function to display add category form
      displayCategoryForm();

      break;

    // For adding FAQ
    case 'addFAQ' :
      // Initialize some variables
      $faqAdded = false;
      $default_answerText = '';
      $default_faqCategory = 0;
      $default_questionText = '';

      // If add faq form is posted
      if (!empty($_POST['questionText']) && !empty($_POST['answerText'])) {
        $_POST['faqCategory'] = (int)$_POST['faqCategory'];
        $_POST['answerText'] = addslashes($_POST['answerText']);
        $_POST['questionText'] = addslashes($_POST['questionText']);

        // Query to insert category into database table
        $query = "INSERT INTO ".$CONFIG['TABLE_PREFIX']."faqs SET categoryId = '".$_POST['faqCategory']."', questionText = '".$_POST['questionText']."', answerText = '".$_POST['answerText']."'";
        cpg_db_query($query);

        $faqAdded = true;
      }

      // Calling function to display add FAQ form
      displayFAQForm();

      break;

    // For editing category or FAQ
    case 'edit' :
      // For editing FAQ
      if (!empty($_REQUEST['faqId'])) {
        $_REQUEST['faqId'] = (int)$_REQUEST['faqId'];

        // Query to fetch faq's details
        $query = "SELECT * FROM ".$CONFIG['TABLE_PREFIX']."faqs WHERE faqId = '".$_REQUEST['faqId']."'";
        $result = cpg_db_query($query);

        if (mysql_num_rows($result) > 0) {
          // Initialize a variable
          $faqUpdated = false;

          // If edit faq form is posted
          if (!empty($_POST['questionText']) && !empty($_POST['answerText'])) {
            $_POST['faqCategory'] = (int)$_POST['faqCategory'];
            $_POST['answerText'] = addslashes($_POST['answerText']);
            $_POST['questionText'] = addslashes($_POST['questionText']);

            // Query to insert category into database table
            $query = "UPDATE ".$CONFIG['TABLE_PREFIX']."faqs SET categoryId = '".$_POST['faqCategory']."', questionText = '".$_POST['questionText']."', answerText = '".$_POST['answerText']."' WHERE faqId = '".$_REQUEST['faqId']."'";
            cpg_db_query($query);

            $faqUpdated = true;
          } else {
            $row = cpg_db_fetch_row($result);

            // Store database results in default variables
            $default_answerText = (empty($_POST['answerText']) ? stripslashes($row['answerText']) : $_POST['answerText']);
            $default_questionText = (empty($_POST['questionText']) ? stripslashes($row['questionText']) : $_POST['questionText']);
            $default_faqCategory = (isset($_POST['faqCategory']) ? (int)$_POST['faqCategory'] : (int)$row['categoryId']);
          }

          // Calling function to display add FAQ form
          displayFAQForm();
        }
      // For editing category
      } else if (!empty($_REQUEST['categoryId'])) {
        $_REQUEST['categoryId'] = (int)$_REQUEST['categoryId'];

        // Query to fetch category's details
        $query = "SELECT * FROM ".$CONFIG['TABLE_PREFIX']."faqCatgeories WHERE categoryId = '".$_REQUEST['categoryId']."'";
        $result = cpg_db_query($query);

        if (mysql_num_rows($result) > 0) {
          // Initialize some variables
          $categoryExists = false;
          $categoryUpdated = false;
          $categoryMoveUnderChild = false;

          // If edit category form is posted
          if (!empty($_POST['categoryTitle'])) {
            $_POST['parentCategory'] = (int)$_POST['parentCategory'];
            $_POST['categoryTitle'] = addslashes($_POST['categoryTitle']);

            // Query to check whether category title already exists or not
            $query = "SELECT * FROM ".$CONFIG['TABLE_PREFIX']."faqCatgeories WHERE categoryTitle = '".$_POST['categoryTitle']."' AND categoryId != '".$_REQUEST['categoryId']."'";
            $result = cpg_db_query($query);

            if (mysql_num_rows($result) > 0) {
              $categoryExists = true;
              $default_parentCategory = $_POST['parentCategory'];
              $default_categoryTitle = stripslashes($_POST['categoryTitle']);
            } else if (isChild($_POST['parentCategory'], $_REQUEST['categoryId'])) {
              $categoryMoveUnderChild = true;
              $default_parentCategory = $_POST['parentCategory'];
              $default_categoryTitle = stripslashes($_POST['categoryTitle']);
            } else {
              // Query to insert category into database table
              $query = "UPDATE ".$CONFIG['TABLE_PREFIX']."faqCatgeories SET parentCategory = '".$_POST['parentCategory']."', categoryTitle = '".$_POST['categoryTitle']."' WHERE categoryId = '".$_REQUEST['categoryId']."'";
              cpg_db_query($query);

              $categoryUpdated = true;
            }
          } else {
            $row = cpg_db_fetch_row($result);

            // Store database results in default variables
            $default_parentCategory = (int)$row['parentCategory'];
            $default_categoryTitle = stripslashes($row['categoryTitle']);
          }

          // Calling function to display add category form
          displayCategoryForm();
        }
      }

      break;
  }
}
?>
<p align="center">[ <a href="#" onClick="window.close();">Close Window</a> ]</p>
</body>
</html>
<?php
exit;

// Function to display add category form
function displayCategoryForm() {
  global $categoryAdded, $categoryExists, $categoryMoveUnderChild, $categoryUpdated, $default_categoryTitle, $thisDomain;

  // Store proper message
  if ($categoryAdded) {
    $message = '<p align="center"><font color="#339966"><b>FAQ category has been added successfully.</b></font></p>';
  } else if ($categoryUpdated) {
    $message = '<p align="center"><font color="#339966"><b>FAQ category has been updated successfully.</b></font></p>';
  } else if ($categoryExists) {
    $message = '<p align="center"><font color="#FF0000"><b>This FAQ category title already exists. Please try another.</b></font></p>';
  } else if ($categoryMoveUnderChild) {
    $message = '<p align="center"><font color="#FF0000"><b>'."Category's parent should not be self or child of it. Please try another.</b></font></p>";
  } else {
    $message = '';
  }

  if ($_REQUEST['act'] == 'edit') {
    $task = 'Edit';
    $hiddenIdField = '<input type="hidden" name="categoryId" value="'.$_REQUEST['categoryId'].'">';
  } else {
    $task = 'Add';
    $hiddenIdField = '';
  }

  echo '
<script language="JavaScript">
<!--
function validateForm(f) {
  if (f.categoryTitle.value == "") {
    alert("Please provide category title");
    f.categoryTitle.focus();
    return false;
  }

  return true;
}
//-->
</script>
<form action="manageFAQ.php" method="post">
<input type="hidden" name="act" value="'.$_REQUEST['act'].'">'.$hiddenIdField.'
<table align="center" border="0" cellpadding="5" cellspacing="0" class="maintable" width="100%">
  <tr><td class="tableh1">'.$task.' FAQ Category</td></tr>
  <tr>
    <td align="center">
      '.$message;

  if ($categoryAdded || $categoryUpdated) {
    echo '
<script language="JavaScript">
<!--
window.opener.location = "'.$thisDomain.'myfaq.php";
//-->
</script>';
  } else {
    echo '
      FAQ category title : <input type="text" name="categoryTitle" size="40" value="'.$default_categoryTitle.'"><br>
      Parent category : '.getMultilevelCategoriesDropdown().'<br>
      <input type="submit" name="submit" value="'.$task.' Category" onClick="return validateForm(this.form);">';
  }

  echo '
    </td>
  </tr>
</table>
</form>';
} // End of function 'displayCategoryForm'

// Function to display add FAQ form
function displayFAQForm() {
  global $faqAdded, $faqUpdated, $default_questionText, $default_answerText, $thisDomain;

  // Store proper message
  if ($faqAdded) {
    $message = '<p align="center"><font color="#339966"><b>FAQ entry has been added successfully.</b></font></p>';
  } else if ($faqUpdated) {
    $message = '<p align="center"><font color="#339966"><b>FAQ entry has been updated successfully.</b></font></p>';
  } else {
    $message = '';
  }

  if ($_REQUEST['act'] == 'edit') {
    $task = 'Edit';
    $hiddenIdField = '<input type="hidden" name="faqId" value="'.$_REQUEST['faqId'].'">';
  } else {
    $task = 'Add';
    $hiddenIdField = '';
  }

  echo '
<script language="JavaScript">
<!--
function validateForm(f) {
  if (f.questionText.value == "") {
    alert("Please provide text for question");
    f.questionText.focus();
    return false;
  }

  if (f.answerText.value == "") {
    alert("Please provide text for answer");
    f.answerText.focus();
    return false;
  }

  return true;
}
//-->
</script>
<form action="manageFAQ.php" method="post">
<input type="hidden" name="act" value="'.$_REQUEST['act'].'">'.$hiddenIdField.'
<table align="center" border="0" cellpadding="5" cellspacing="0" class="maintable" width="100%">
  <tr><td class="tableh1">'.$task.' FAQ Entry</td></tr>
  <tr>
    <td>
      '.$message;

  if ($faqAdded || $faqUpdated) {
    echo '
<script language="JavaScript">
<!--
window.resizeTo(500, 150);
window.opener.location = "'.$thisDomain.'myfaq.php";
//-->
</script>';
  } else {
    echo '
      FAQ category :'.getCategoriesDropdown().'<br><br>
      FAQ question text :<br>
      <textarea name="questionText" cols="60" rows="5">'.$default_questionText.'</textarea><br><br>
      FAQ answer text :<br>
      <textarea name="answerText" cols="60" rows="20">'.$default_answerText.'</textarea><br><br>
      <center><input type="submit" name="submit" value="'.$task.' FAQ" onClick="return validateForm(this.form);"></center>';
  }

  echo '
    </td>
  </tr>
</table>
</form>';
} // End of function 'displayFAQForm'

// Function to get drop-down menu for categories
function getCategoriesDropDown() {
  global $catArr, $default_faqCategory;

  $catArr = array();
  getCategoryTree();

  $cdd = '
      <select name="faqCategory">
        <option value="0">No category</option>';

  if (count($catArr) > 0) {
    foreach ($catArr as $catId => $catDetails) {
      if ($catId == $default_faqCategory) {
        $selected = ' SELECTED';
      } else {
        $selected = '';
      }

      $spaces = '';

      if ($catDetails['level'] > 0) {
        $spaces .= '|';
      }

      for ($i = 0; $i < $catDetails['level']; $i++) {
        $spaces .= '--';
      }

      if (!empty($spaces)) {
        $spaces .= '&nbsp;';
      }

      if ($catDetails['level'] > 0) {
        $cdd .= '
        <option value="'.$catId.'"'.$selected.'>'.$spaces.$catDetails['title'].'</option>';
      } else {
        $cdd .= '
        <option style="font-weight: bold;" value="'.$catId.'"'.$selected.'>'.$catDetails['title'].'</option>';
      }
    }
  }

  $cdd .= '
      </select>';

  return $cdd;
} // End of function 'getCategoriesDropDown'

?>
